/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*		"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.		*
*																		*
*  Copyright (C) 1984, 2011 Lugaru Software Ltd.  All rights reserved.	*
*																		*
* Limited permission is hereby granted to reproduce and modify this		*
* copyrighted material provided that the resulting code is used only in *
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.								*
************************************************************************/

// For updating from 13.10 to 13.11.

#include "eel.h"
#include "tex.h"
#include "vspell.h"

command latex_mode()
{
	tex_force_latex = 1;
	tex_mode();
}

int spell_download_one(char *dir, char *arch, int sz, int ask)
{
	char archpath[FNAMELEN], url[FNAMELEN], cmdline[FNAMELEN], *s;
	struct file_info fi;
	sprintf(archpath, "%s/%s", dir, arch);
	sprintf(url, "http://www.lugaru.com/%s", arch);
	s = lookpath(arch);
	if (check_file(archpath, &fi) != CHECK_FILE || fi.fsize * 10 < sz * 9) {
		if (s && check_file(s, &fi) == CHECK_FILE && fi.fsize * 10 >= sz * 9)
			strcpy(archpath, s);
		else if (!ask)
			return 0;
		else if (!ask_yn("Download and install dictionary file?", 
						 "Download and install a dictionary file "
						 "(about 700 KB)? ", "Yes", "No", 1))
			return 1;
		else {
			say("Please wait...");
			if (download_file_to_disk(url, archpath, sz))
				error("Couldn't download dictionary file from %s", url);
		}
	}
	if (check_file(archpath, &fi) != CHECK_FILE || fi.fsize * 10 < sz * 9)
		error("Bad dictionary archive %f, please retrieve manually.",
			  archpath);
	convert_to_8_3_filename(archpath);
	sprintf(cmdline, is_win32 ? "\"%s\"" : "\"tar\" xzf \"%s\"", archpath);
	pipe_text(NULL, "-spell-config", cmdline,
			  dir, PIPE_SYNCH | PIPE_NOREFRESH, 0);
	return 2;
}
