/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*		"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.		*
*																		*
*  Copyright (C) 1984, 2011 Lugaru Software Ltd.  All rights reserved.	*
*																		*
* Limited permission is hereby granted to reproduce and modify this		*
* copyrighted material provided that the resulting code is used only in *
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.								*
************************************************************************/

// For updating from 13.11 to 13.12.

#include "eel.h"
#include "dired.h"

char *dired_skip_line_pat();

dired_strip_dotfiles()
{
	char name[FNAMELEN];
	int filecnt = 0, dircnt = 0, specialcnt = 0;

	if (dired_force_show_dotfiles || dired_show_dotfiles == 15
		  || dired_format && dired_format != DF_UNIX)
		return;
	if (string_matches_pattern(get_dired_buffer_pattern(),
							   ".*(^|[,;{/\\])%.%.?[^./\\]+$"))
		return;		// Pattern explicitly mentions dotfile.
	save_var modified, point = 0;
	for (; search(1, " ."); to_end_line()) { // Quickly get to possible dotfile.
		if (give_end_line() >= size())	// Don't do partial lines at eof.
			break;
		to_begin_line();
		if (parse_string(1, dired_skip_line_pat()))
			continue;		// Ignore directory separator lines.
		dired_getindex(name, goal_column);
		if (*name == '.') {
			if (strlen(name) > 1 && is_path_separator(name[strlen(name) - 1]))
				name[strlen(name) - 1] = 0;
			if (!strcmp(name, ".")) {
				if (dired_show_dotfiles & 1)
					continue;
				specialcnt++;
			} else if (!strcmp(name, "..")) {
				if (dired_show_dotfiles & 2)
					continue;
				specialcnt++;
			} else if (!dired_isdir()) {
				if (dired_show_dotfiles & 8)
					continue;
				filecnt++;
			} else {
				if (dired_show_dotfiles & 4)
					continue;
				dircnt++;
			}
			delete(give_begin_line() - 1, give_end_line());
		}
		check_abort();
	}
	point = size();
	if (character(point - 1) == '\n' && (filecnt || dircnt)
		  && !(dired_show_dotfiles & 16))
		bprintf("  %d file%s, %d director%s omitted due to "
				"dired-show-dotfiles\n",
				filecnt, filecnt == 1 ? "" : "s",
				dircnt + specialcnt, dircnt + specialcnt == 1 ? "y" : "ies");
}
